module("luci.model.cbi.cns_server/api/cns",package.seeall)
local s=require"nixio.fs"
local t=require"luci.sys"
local e=require"luci.model.uci".cursor()
local n=require"luci.util"
local i=require"luci.i18n"
local e=require"luci.model.ipkg"
local e="cns_server"
local u="https://api.github.com/repos/mmmdbybyd/CNS/releases/latest"
local l="/usr/bin/wget"
local f={"--no-check-certificate","--quiet","--timeout=100","--tries=3"}
local r=300
local o=nil
local a=nil
local c=false
local function d(t,e)
e=e or 1
if t[e]~=nil then return t[e],d(t,e+1)end
end
local function h(h,r,i,o)
local a=require"os"
local e=require"nixio"
local s,n=e.pipe()
local t=e.fork()
if t>0 then
n:close()
if i or o then
local n=a.time()
while true do
if o and a.difftime(a.time(),n)>=o then
e.kill(t,e.const.SIGTERM)
return 1
end
if i then
local e=s:read(2048)
if e and#e>0 then
i(e)
end
end
local n,a,t=e.waitpid(t,"nohang")
if n and a=="exited"then return t end
if not i and o then e.nanosleep(1)end
end
else
local a,e,t=e.waitpid(t)
return a and e=="exited"and t
end
elseif t==0 then
e.dup(n,e.stdout)
s:close()
n:close()
e.exece(h,r,nil)
e.stdout:close()
a.exit(1)
end
end
local function y(t,e,o)
local a=table
local i=n.split(t,"[%.%-]",nil,true)
local o=n.split(o,"[%.%-]",nil,true)
local t=a.getn(i)
local a=a.getn(o)
if(t<a)then t=a end
for t=1,t,1 do
local a=i[t]or""
local t=o[t]or""
if e=="~="and(a~=t)then return true end
if(e=="<"or e=="<=")and(a<t)then return true end
if(e==">"or e==">=")and(a>t)then return true end
if(a~=t)then return false end
end
return not(e=="<"or e==">")
end
local function w()
local e=nixio.uname().machine or""
if s.access("/usr/lib/os-release")then
o=t.exec("echo -n `grep 'LEDE_BOARD' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}'`")
end
if s.access("/etc/openwrt_release")then
a=t.exec("echo -n `grep 'DISTRIB_TARGET' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}'`")
end
if e=="mips"then
if o and o~=""then
if string.match(o,"ramips")=="ramips"then
e="ramips"
else
e=t.exec("echo '"..o.."' | grep -oE 'ramips|ar71xx'")
end
elseif a and a~=""then
if string.match(a,"ramips")=="ramips"then
e="ramips"
else
e=t.exec("echo '"..a.."' | grep -oE 'ramips|ar71xx'")
end
end
end
return n.trim(e)
end
local function m(t)
local e=""
local i=""
if t=="x86_64"then
e="amd64"
elseif t=="aarch64"then
e="arm64"
elseif t=="ramips"then
e="mipsle"
elseif t=="ar71xx"then
e="mips"
elseif t:match("^i[%d]86$")then
e="386"
elseif t:match("^armv[5-8]")then
e="arm"
i=t:match("[5-8]")
if o and string.match(o,"bcm53xx")=="bcm53xx"then
i="5"
elseif a and string.match(a,"bcm53xx")==
"bcm53xx"then
i="5"
end
i="5"
if i=="7"then c=true end
end
return e,i
end
local function a(e)
local a=require"luci.jsonc"
local o={}
local e=t.exec(l.." --no-check-certificate --timeout=10 -t 1 -O- "..e)
if e==""then return{}end
return a.parse(e)or{}
end
function get_cns_file_path()return"/usr/bin"end
function get_cns_version()
if get_cns_file_path()and get_cns_file_path()~=""then
if s.access(get_cns_file_path().."/cns")then
return t.exec("echo -n `"..get_cns_file_path().."/cns -help 2>&1 | sed -n 3p | awk '{print $4}')$'\n'".."`")
end
end
return""
end
function to_check(e)
if not e or e==""then e=w()end
local s,e=m(e)
if s==""then
return{
code=1,
error=i.translate("Can't determine ARCH, or ARCH not supported.")
}
end
local e=a(u)
if e.tag_name==nil then
return{
code=1,
error=i.translate("Get remote version info failed.")
}
end
local a=e.tag_name:match("[^v]+")
local t=y(get_cns_version(),"<",a)
local o,n
if t then
o=e.html_url
for t,e in ipairs(e.assets)do
if e.name and e.name:match("linux%_"..s)then
n=e.browser_download_url
break
end
end
end
if t and not n then
return{
code=1,
now_version=get_cns_version(),
version=a,
html_url=o,
error=i.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
update=t,
now_version=get_cns_version(),
version=a,
url={html=o,download=n}
}
end
function to_download(e)
if not e or e==""then
return{code=1,error=i.translate("Download url is required.")}
end
t.call("/bin/rm -f /tmp/cns_download.*")
local t=n.trim(n.exec("mktemp -u -t cns_download.XXXXXX"))
local a=h(l,{"-O",t,e,d(f)},nil,r)==0
if not a then
h("/bin/rm",{"-f",t})
return{
code=1,
error=i.translatef("File download failed or timed out: %s",e)
}
end
return{code=0,file=t}
end
function to_move(e)
if not e or e==""then
t.call("/bin/rm -rf /tmp/cns_download*")
return{code=1,error=i.translate("Client file is required.")}
end
local a=get_cns_file_path()
local a=a.."/cns"
local o=nil
o=h("/bin/mv",{"-f",e,a},nil,r)==0
if not o or not s.access(a)then
t.call("/bin/rm -rf "..e)
return{
code=1,
error=i.translatef("Can't move new file to: %s",a)
}
end
h("/bin/chmod",{"-R","755",a})
t.call("/bin/rm -rf "..e)
return{code=0}
end
