local o=require"luci.dispatcher"
local i=require("luci.http")
local n=require("luci.sys")
local a=Map('cns_server')
a.title=translate("CNS Server")
t=a:section(TypedSection,"global",translate("Global Settings"))
t.anonymous=true
t.addremove=false
e=t:option(Flag,"enable",translate("Enable"))
e.rmempty=false
t:append(Template("cns_server/cns"))
t=a:section(TypedSection,"user",translate("Users Manager"))
t.anonymous=true
t.addremove=true
t.template="cbi/tblsection"
t.extedit=o.build_url("admin","services","cns_server","config","%s")
function t.create(t,e)
local e=luci.sys.exec("echo -n $(cat /proc/sys/kernel/random/uuid)")or""
e=string.gsub(e,"-","")
local t=TypedSection.create(t,e)
i.redirect(o.build_url("admin","services","cns_server","config",e))
end
function t.remove(t,a)
t.map.proceed=true
t.map:del(a)
i.redirect(o.build_url("admin","services","cns_server"))
end
e=t:option(Flag,"enable",translate("Enable"))
e.width="5%"
e.rmempty=false
e=t:option(DummyValue,"status",translate("Status"))
e.rawhtml=true
e.width="10%"
e.cfgvalue=function(t,e)
return string.format('<font class="users_status" hint="%s">%s</font>',e,translate("Collecting data..."))
end
a:append(Template("cns_server/users_list_status"))
e=t:option(DummyValue,"remarks",translate("Remarks"))
e=t:option(DummyValue,"port",translate('Port'))
e.width="10%"
e.value=function(o,t)
local o=""
local t=a:get(t,"port")
if not t or t==""then return o end;
return table.concat(t,"|")
end
e=t:option(DummyValue,'proxy_key',translate('Proxy Key'))
e.width="10%"
e=t:option(DummyValue,'encrypt_password',translate("Password"))
e.width="10%"
e=t:option(DummyValue,"tls","Tls")
e.width="10%"
e.rawhtml=true
e.cfgvalue=function(e,t)
local e=string.format("X")
local t=a:get(t,"tls")
if t=="1"then e=string.format("✓")end
return e;
end
a:append(Template("cns_server/log"))
a.on_after_commit=function(e)
if e.changed then
n.exec("/etc/init.d/cns_server restart")
end
end
return a