local t=require"luci.dispatcher"
local e="cns_server"
local a=require"luci.sys"
m=Map(e,translate("Server Config"))
m.redirect=t.build_url("admin","services",e)
s=m:section(NamedSection,arg[1],"user","")
s.addremove=false
s.dynamic=false
enable=s:option(Flag,"enable",translate("Enabled"))
remark=s:option(Value,"remarks",translate("Remarks"))
port=s:option(DynamicList,"port",translate("ports"))
port.default="2222"
port.datatype="range(1,65535)"
proxy_host=s:option(Value,"proxy_key",translate("Proxy Key"),translate("Set the KEY of the HOST obtained in the request header, the default HOST"))
proxy_host.default="Host"
encrypt_password=s:option(Value,"encrypt_password",translate("Password"))
encrypt_password.default="password"
tls=s:option(Flag,"tls",translate("TLS"))
tls.default=0
tls.validate=function(a,e,t)
if e then
if e=="1"then
local e=tls_certificateFile:formvalue(t)or""
local t=tls_keyFile:formvalue(t)or""
if e==""or t==""then
return nil,translate("Public key and Private key path can not be empty!")
end
end
return e
end
end
auto_cert_hosts=s:option(DynamicList,'tls_auto_cert_host','指定Host',"")
auto_cert_hosts:depends('tls',1)
cert_file=s:option(Value,"tls_cert_file","Public key absolute path",translate('example')..":/etc/ssl/cert.pem")
cert_file:depends('tls',1)
key_file=s:option(Value,'tls_key_file','Private key absolute path',translate('example')..":/etc/ssl/key.pem")
key_file:depends('tls',1)
tcp_timeout=s:option(Value,'Tcp_timeout',translate("Tcp timeout"))
tcp_timeout.default=600
udp_timeout=s:option(Value,'Udp_timeout',translate("UDP超时时间"))
udp_timeout.default=30
enable_dns_tcpOverUdp=s:option(Flag,'Enable_dns_tcpOverUdp',translate("tcpDNS to udpDNS"),translate("Turn on tcpDNS to udpDNS, which can slightly speed up the DNS resolution speed, and it is disabled by default"))
enable_dns_tcpOverUdp.default=0
enable_httpDNS=s:option(Flag,"Enable_httpDNS",translate("Enable tcpDNS"),translate("Enable TcpDNS, HTTPDNS does not require http_tunnel handshake, which can slightly speed up DNS resolution, and is disabled by default"))
enable_httpDNS.default=0
Enable_TFO=s:option(Flag,"Enable_TFO",translate("Enable tcpFastOpen"),translate("Turn on tcpFastOpen, which can slightly speed up the connection creation speed (free flow may not be applicable), and it is closed by default"))
Enable_TFO.default=false
m.on_after_commit=function(e)
if e.changed then
a.exec("/etc/init.d/cns_server restart")
end
end
return m